Angular Tabs Properties

An object defining configuration properties for the Tabs UI component.

accessKey

Specifies the shortcut key that sets focus on the UI component.

Type:

String

Default Value: undefined

The value of this property will be passed to the accesskey attribute of the HTML element that underlies the UI component.

dataSource

Binds the UI component to data.

Default Value: null

The Tabs works with collections of string values or objects.

Depending on your data source, bind the Tabs to data as follows. If the data source provides objects, also specify the itemTemplate. You can skip this part if the objects contain fields described in the items section.

  • Data Array
    Assign the array to the dataSource option.

  • Read-Only Data in JSON Format
    Set the dataSource property to the URL of a JSON file or service that returns JSON data.

  • OData
    Implement an ODataStore.

  • Web API, PHP, MongoDB
    Use one of the following extensions to enable the server to process data according to the protocol DevExtreme UI components use:

    Then, use the createStore method to configure access to the server on the client as shown below. This method is part of DevExtreme.AspNet.Data.

    app.component.ts
    app.component.html
    app.module.ts
    • import { Component } from '@angular/core';
    • import CustomStore from 'devextreme/data/custom_store';
    • import { createStore } from 'devextreme-aspnet-data-nojquery';
    •  
    • @Component({
    • selector: 'app-root',
    • templateUrl: './app.component.html',
    • styleUrls: ['./app.component.css']
    • })
    • export class AppComponent {
    • store: CustomStore;
    • constructor() {
    • let serviceUrl = "https://url/to/my/service";
    • this.store = createStore({
    • key: "ID",
    • loadUrl: serviceUrl + "/GetAction",
    • insertUrl: serviceUrl + "/InsertAction",
    • updateUrl: serviceUrl + "/UpdateAction",
    • deleteUrl: serviceUrl + "/DeleteAction"
    • })
    • }
    • }
    • <dx-tabs ...
    • [dataSource]="store">
    • </dx-tabs>
    • import { BrowserModule } from '@angular/platform-browser';
    • import { NgModule } from '@angular/core';
    • import { AppComponent } from './app.component';
    •  
    • import { DxTabsModule } from 'devextreme-angular';
    •  
    • @NgModule({
    • declarations: [
    • AppComponent
    • ],
    • imports: [
    • BrowserModule,
    • DxTabsModule
    • ],
    • providers: [],
    • bootstrap: [AppComponent]
    • })
    • export class AppModule { }
  • Any other data source
    Implement a CustomStore.

Regardless of the data source on the input, the Tabs always wraps it in the DataSource object. This object allows you to sort, filter, group, and perform other data shaping operations. To get its instance, call the getDataSource() method.

NOTE

Review the following notes about data binding:

  • Do not specify the items property if you specified the dataSource, and vice versa.

  • Data field names cannot be equal to this and should not contain the following characters: ., :, [, and ].

  • The stores are immutable. You cannot change their configurations at runtime. Instead, create a new store or DataSource and assign it to the dataSource property as shown in the following help topic: Two-Way Property Binding.

disabled

Specifies whether the UI component responds to user interaction.

Type:

Boolean

Default Value: false

elementAttr

Specifies the global attributes to be attached to the UI component's container element.

Selector: dxo-element-attr
Type:

Object

Default Value: {}

HTML
TypeScript
  • <dx-tabs ...
  • [elementAttr]="{ id: 'elementId', class: 'class-name' }">
  • </dx-tabs>
  • import { DxTabsModule } from "devextreme-angular";
  • // ...
  • export class AppComponent {
  • // ...
  • }
  • @NgModule({
  • imports: [
  • // ...
  • DxTabsModule
  • ],
  • // ...
  • })

focusStateEnabled

Specifies whether the UI component can be focused using keyboard navigation.

Type:

Boolean

Default Value: true (desktop)

height

Specifies the UI component's height.

Type:

Number

|

String

|

Function

Return Value:

Number

|

String

The UI component's height.

Default Value: undefined

This property accepts a value of one of the following types:

  • Number
    The height in pixels.

  • String
    A CSS-accepted measurement of height. For example, "55px", "20vh", "80%", "inherit".

  • Function (deprecated since v21.2)
    Refer to the W0017 warning description for information on how you can migrate to viewport units.

hint

Specifies text for a hint that appears when a user pauses on the UI component.

Type:

String

Default Value: undefined

hoverStateEnabled

Specifies whether the UI component changes its state when a user pauses on it.

Type:

Boolean

Default Value: true

itemHoldTimeout

The time period in milliseconds before the onItemHold event is raised.

Type:

Number

Default Value: 750

items[]

An array of items displayed by the UI component.

Selector: dxi-item
Type:

Array<String | dxTabsItem | any>

Raised Events: onOptionChanged

The items array can contain:

  • Strings
  • Objects with fields described in this section
  • Objects with any other fields. In this case, specify the itemTemplate.

If you need to update the UI component items, reassign the entire items array as shown in the following example:

JavaScript
  • tabsInstance.option('items', newItems);

As an alternative to items, you can use the dataSource property. It accepts the DataSource object, whose underlying stores provide an API that allows you to update individual items without reassigning the entire item collection.

NOTE
Do not use the items property if you use dataSource, and vice versa.

itemTemplate

Specifies a custom template for items.

Type:

template

Template Data:

Object

The item object to be rendered.

Default Name: 'item'

keyExpr

Specifies the key property that provides key values to access data items. Each key value must be unique.

Type:

String

|

Function

Default Value: null

noDataText

Specifies the text or HTML markup displayed by the UI component if the item collection is empty.

Type:

String

Default Value: 'No data to display'

The Tabs component evaluates the noDataText property's value. This evaluation, however, makes the Tabs potentially vulnerable to XSS attacks. To guard against these attacks, encode the HTML markup before you assign it to the noDataText property. Refer to the following help topic for more information: Potentially Vulnerable API - noDataText.

onContentReady

A function that is executed when the UI component is rendered and each time the component is repainted.

Type:

Function

Function parameters:
e:

Object

Information about the event.

Object structure:
Name Type Description
component

Tabs

The UI component's instance.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

model any

Model data. Available only when using Knockout.

Default Value: null

onDisposing

A function that is executed before the UI component is disposed of.

Type:

Function

Function parameters:
e:

Object

Information about the event.

Object structure:
Name Type Description
component

Tabs

The UI component's instance.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

model any

Model data. Available only if you use Knockout.

Default Value: null

onInitialized

A function used in JavaScript frameworks to save the UI component instance.

Type:

Function

Function parameters:
e:

Object

Information about the event.

Object structure:
Name Type Description
component

Tabs

The UI component's instance.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

Default Value: null

onItemClick

A function that is executed when a collection item is clicked or tapped.

Type:

Function

Function parameters:
e:

Object

Information about the event.

Object structure:
Name Type Description
component

Tabs

The UI component's instance.

element

HTMLElement | jQuery

The UI component's container.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

itemData

Object

The clicked item's data.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemIndex

Number

The clicked item's index.

model any

Model data. Available only if you use Knockout.

Default Value: null

onItemContextMenu

A function that is executed when a collection item is right-clicked or pressed.

Type:

Function

Function parameters:
e:

Object

Information about the event.

Object structure:
Name Type Description
component

Tabs

The UI component's instance.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

itemData

Object

The item's data.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemIndex

Number

The item's index.

model any

Model data. Available only if you use Knockout.

Default Value: null

onItemHold

A function that is executed when a collection item has been held for a specified period.

Type:

Function

Function parameters:
e:

Object

Information about the event.

Object structure:
Name Type Description
component

Tabs

The UI component's instance.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

itemData

Object

The data of the item being held.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemIndex

Number

The item's index.

model any

Model data. Available only if you use Knockout.

Default Value: null

onItemRendered

A function that is executed after a collection item is rendered.

Type:

Function

Function parameters:
e:

Object

Information about the event.

Object structure:
Name Type Description
component

Tabs

The UI component's instance.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemData

Object

The current item's data.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemIndex

Number

The current item's index.

model any

Model data. Available only if you use Knockout.

Default Value: null

onOptionChanged

A function that is executed after a UI component property is changed.

Type:

Function

Function parameters:
e:

Object

Information about the event.

Object structure:
Name Type Description
model any

Model data. Available only if you use Knockout.

fullName

String

The path to the modified property that includes all parent properties.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Tabs

The UI component's instance.

name

String

The modified property if it belongs to the first level. Otherwise, the first-level property it is nested into.

value any

The modified property's new value.

previousValue any

The UI component's previous value.

Default Value: null

The following example shows how to subscribe to component property changes:

app.component.html
app.component.ts
app.module.ts
  • <dx-tabs ...
  • (onOptionChanged)="handlePropertyChange($event)">
  • </dx-tabs>
  • import { Component } from '@angular/core';
  •  
  • @Component({
  • selector: 'app-root',
  • templateUrl: './app.component.html',
  • styleUrls: ['./app.component.css']
  • })
  •  
  • export class AppComponent {
  • // ...
  • handlePropertyChange(e) {
  • if(e.name === "changedProperty") {
  • // handle the property change here
  • }
  • }
  • }
  • import { BrowserModule } from '@angular/platform-browser';
  • import { NgModule } from '@angular/core';
  • import { AppComponent } from './app.component';
  • import { DxTabsModule } from 'devextreme-angular';
  •  
  • @NgModule({
  • declarations: [
  • AppComponent
  • ],
  • imports: [
  • BrowserModule,
  • DxTabsModule
  • ],
  • providers: [ ],
  • bootstrap: [AppComponent]
  • })
  •  
  • export class AppModule { }

onSelectionChanged

A function that is executed when a collection item is selected or selection is canceled.

Type:

Function

Function parameters:
e:

Object

Information about the event.

Object structure:
Name Type Description
addedItems

Array<any>

The data of the items that have been selected.

component

Tabs

The UI component's instance.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

model any

Model data. Available only if you use Knockout.

removedItems

Array<any>

The data of the items whose selection has been canceled.

Default Value: null

repaintChangesOnly

Specifies whether to repaint only those elements whose data changed.

Type:

Boolean

Default Value: false

See Also

rtlEnabled

Switches the UI component to a right-to-left representation.

Type:

Boolean

Default Value: false

When this property is set to true, the UI component text flows from right to left, and the layout of elements is reversed. To switch the entire application/site to the right-to-left representation, assign true to the rtlEnabled field of the object passed to the DevExpress.config(config) method.

JavaScript
  • DevExpress.config({
  • rtlEnabled: true
  • });

DataGrid Demo Navigation UI Demo Editors Demo

scrollByContent

Specifies whether or not an end user can scroll tabs by swiping.

Type:

Boolean

Default Value: true, false (desktop)

scrollingEnabled

Specifies whether or not an end user can scroll tabs.

Type:

Boolean

Default Value: true

selectedIndex

The index of the currently selected UI component item.

Type:

Number

Default Value: -1
Raised Events: onSelectionChanged

selectedItem

The selected item object.

Type: any
Default Value: null
Raised Events: onSelectionChanged

selectedItemKeys

Specifies an array of currently selected item keys.

Type:

Array<any>

Raised Events: onSelectionChanged

The item keys can be specified using the keyExpr property or the key property within the underlying Store.

See Also

selectedItems

An array of currently selected item objects.

Type:

Array<any>

Raised Events: onSelectionChanged

selectionMode

Specifies whether the UI component enables an end user to select only a single item or multiple items.

Type:

String

Default Value: 'single'
Accepted Values: 'single' | 'multiple'

showNavButtons

Specifies whether navigation buttons should be available when tabs exceed the UI component's width.

Type:

Boolean

Default Value: true, false (mobile devices)

tabIndex

Specifies the number of the element when the Tab key is used for navigating.

Type:

Number

Default Value: 0

The value of this property will be passed to the tabindex attribute of the HTML element that underlies the UI component.

visible

Specifies whether the UI component is visible.

Type:

Boolean

Default Value: true

width

Specifies the UI component's width.

Type:

Number

|

String

|

Function

Return Value:

Number

|

String

The UI component's width.

Default Value: undefined

This property accepts a value of one of the following types:

  • Number
    The width in pixels.

  • String
    A CSS-accepted measurement of width. For example, "55px", "20vw", "80%", "auto", "inherit".

  • Function (deprecated since v21.2)
    Refer to the W0017 warning description for information on how you can migrate to viewport units.

Vue Tabs Props
accessKey
The value of this property will be passed to the accesskey
attribute of the HTML element that underlies the UI component.
dataSource
The Tabs works with collections of string
values or objects.
Depending on your data source, bind the Tabs to data as follows. If the data source provides objects, also specify the itemTemplate. You can skip this part if the objects contain fields described in the items section.
Data Array
Assign the array to the dataSource option.Read-Only Data in JSON Format
Set the dataSource property to the URL of a JSON file or service that returns JSON data.OData
Implement an ODataStore.Web API, PHP, MongoDB
Use one of the following extensions to enable the server to process data according to the protocol DevExtreme UI components use:Then, use the createStore method to configure access to the server on the client as shown below. This method is part of DevExtreme.AspNet.Data.
App.vue- <template>
- <DxTabs ...
- :data-source="store" />
- </template>
- <script>
- import 'devextreme/dist/css/dx.light.css';
- import CustomStore from 'devextreme/data/custom_store';
- import { createStore } from 'devextreme-aspnet-data-nojquery';
- import { DxTabs } from 'devextreme-vue/tabs';
- export default {
- components: {
- DxTabs
- },
- data() {
- const serviceUrl = "https://url/to/my/service";
- const store = createStore({
- key: "ID",
- loadUrl: serviceUrl + "/GetAction",
- insertUrl: serviceUrl + "/InsertAction",
- updateUrl: serviceUrl + "/UpdateAction",
- deleteUrl: serviceUrl + "/DeleteAction"
- });
- return {
- store
- }
- }
- }
- </script>
Any other data source
Implement a CustomStore.
Regardless of the data source on the input, the Tabs always wraps it in the DataSource object. This object allows you to sort, filter, group, and perform other data shaping operations. To get its instance, call the getDataSource() method.
Review the following notes about data binding:
Do not specify the items property if you specified the dataSource, and vice versa.
Data field names cannot be equal to
this
and should not contain the following characters:.
,:
,[
, and]
.
- The stores are immutable. You cannot change their configurations at runtime. Instead, create a new store or DataSource and assign it to the dataSource property as shown in the following help topic: Two-Way Property Binding.
height
This property accepts a value of one of the following types:
Number
The height in pixels.String
A CSS-accepted measurement of height. For example,"55px"
,"20vh"
,"80%"
,"inherit"
.Function (deprecated since v21.2)
Refer to the W0017 warning description for information on how you can migrate to viewport units.
items[]
The items array can contain:
- Strings
- Objects with fields described in this section
- Objects with any other fields. In this case, specify the itemTemplate.
If you need to update the UI component items, reassign the entire items array as shown in the following example:
- tabsInstance.option('items', newItems);
As an alternative to items, you can use the dataSource property. It accepts the DataSource object, whose underlying stores provide an API that allows you to update individual items without reassigning the entire item collection.
keyExpr
Specifies the key property that provides key values to access data items. Each key value must be unique.
noDataText
The Tabs component evaluates the noDataText property's value. This evaluation, however, makes the Tabs potentially vulnerable to XSS attacks. To guard against these attacks, encode the HTML markup before you assign it to the noDataText property. Refer to the following help topic for more information: Potentially Vulnerable API - noDataText.
onContentReady
A function that is executed when the UI component is rendered and each time the component is repainted.
Name | Type | Description |
---|---|---|
component |
The UI component's instance. |
|
element |
The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model | any |
Model data. Available only when using Knockout. |
onDisposing
A function that is executed before the UI component is disposed of.
Name | Type | Description |
---|---|---|
component |
The UI component's instance. |
|
element |
The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model | any |
Model data. Available only if you use Knockout. |
onInitialized
Name | Type | Description |
---|---|---|
component |
The UI component's instance. |
|
element |
The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery. |
onItemClick
Name | Type | Description |
---|---|---|
component |
The UI component's instance. |
|
element |
The UI component's container. |
|
event | Event (jQuery or EventObject) |
The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery. |
itemData |
The clicked item's data. |
|
itemElement |
The item's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
itemIndex |
The clicked item's index. |
|
model | any |
Model data. Available only if you use Knockout. |
onItemContextMenu
Name | Type | Description |
---|---|---|
component |
The UI component's instance. |
|
element |
The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
event | Event (jQuery or EventObject) |
The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery. |
itemData |
The item's data. |
|
itemElement |
The item's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
itemIndex |
The item's index. |
|
model | any |
Model data. Available only if you use Knockout. |
onItemHold
A function that is executed when a collection item has been held for a specified period.
Name | Type | Description |
---|---|---|
component |
The UI component's instance. |
|
element |
The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
event | Event (jQuery or EventObject) |
The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery. |
itemData |
The data of the item being held. |
|
itemElement |
The item's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
itemIndex |
The item's index. |
|
model | any |
Model data. Available only if you use Knockout. |
onItemRendered
Name | Type | Description |
---|---|---|
component |
The UI component's instance. |
|
element |
The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
itemData |
The current item's data. |
|
itemElement |
The item's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
itemIndex |
The current item's index. |
|
model | any |
Model data. Available only if you use Knockout. |
onOptionChanged
Name | Type | Description |
---|---|---|
model | any |
Model data. Available only if you use Knockout. |
fullName |
The path to the modified property that includes all parent properties. |
|
element |
The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
component |
The UI component's instance. |
|
name |
The modified property if it belongs to the first level. Otherwise, the first-level property it is nested into. |
|
value | any |
The modified property's new value. |
previousValue | any |
The UI component's previous value. |
The following example shows how to subscribe to component property changes:
- <template>
- <DxTabs ...
- @option-changed="handlePropertyChange"
- />
- </template>
- <script>
- import 'devextreme/dist/css/dx.light.css';
- import DxTabs from 'devextreme-vue/tabs';
- export default {
- components: {
- DxTabs
- },
- // ...
- methods: {
- handlePropertyChange: function(e) {
- if(e.name === "changedProperty") {
- // handle the property change here
- }
- }
- }
- }
- </script>
onSelectionChanged
Name | Type | Description |
---|---|---|
addedItems | Array<any> |
The data of the items that have been selected. |
component |
The UI component's instance. |
|
element |
The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model | any |
Model data. Available only if you use Knockout. |
removedItems | Array<any> |
The data of the items whose selection has been canceled. |
repaintChangesOnly
See Also
- push(changes) in: ArrayStore | CustomStore | LocalStore | ODataStore
- DataSource.reshapeOnPush
rtlEnabled
When this property is set to true, the UI component text flows from right to left, and the layout of elements is reversed. To switch the entire application/site to the right-to-left representation, assign true to the rtlEnabled field of the object passed to the DevExpress.config(config) method.
- DevExpress.config({
- rtlEnabled: true
- });
selectedItemKeys
The item keys can be specified using the keyExpr property or the key property within the underlying Store.
See Also
- key in ArrayStore | CustomStore | LocalStore | ODataStore
selectionMode
Specifies whether the UI component enables an end user to select only a single item or multiple items.
tabIndex
The value of this property will be passed to the tabindex
attribute of the HTML element that underlies the UI component.
width
This property accepts a value of one of the following types:
Number
The width in pixels.String
A CSS-accepted measurement of width. For example,"55px"
,"20vw"
,"80%"
,"auto"
,"inherit"
.Function (deprecated since v21.2)
Refer to the W0017 warning description for information on how you can migrate to viewport units.
If you have technical questions, please create a support ticket in the DevExpress Support Center.